#include <stdarg.h>
#include <string.h>

#define NONAMELESSUNION
#define NONAMELESSSTRUCT

#include "windef.h"
#include "winbase.h"
#include "wingdi.h"
#include "winuser.h"
#include "winreg.h"
#include "ole2.h"
#include "riched32.h"
#include "richedit.h"
#include "richole.h"
#include "wine/debug.h"

WINE_DEFAULT_DEBUG_CHANNEL(richedit);

static ICOM_VTABLE(IRichEditOle) REvt;

typedef struct _IRichEditOle {
    void *lpVtbl;
    DWORD ref;
} _IRichEditOle;


LPVOID* WINAPI CreateIRichEditOle()
{
    _IRichEditOle *REO;

    REO = HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY,
                                    sizeof(_IRichEditOle));

    if (REO == NULL)
        return NULL;

    REO->lpVtbl = & REvt;
    REO->ref = 1;
    TRACE("Created %p\n",REO);
    return (LPVOID) REO;
}

static HRESULT WINAPI IRichEditOle_fnQueryInterface(IRichEditOle *me, REFIID
                                                  riid, LPVOID *ppvObj)
{
    ICOM_THIS(IRichEditOle,me);
    FIXME("Stub (%p)\n",This);
 
    return 0x0;   
}

static ULONG WINAPI IRichEditOle_fnAddRef(IRichEditOle *me)
{
    ICOM_THIS(_IRichEditOle,me);
    FIXME("Stub (%p)\n",This);

    return ++(This->ref);
}

static ULONG WINAPI IRichEditOle_fnRelease(IRichEditOle *me)
{
    ICOM_THIS(_IRichEditOle,me);

    TRACE ("(%p)->(count=%lu)\n", This, This->ref);

    if (!--(This->ref)) {
        TRACE ("Destroying (%p)\n", This);
        HeapFree(GetProcessHeap(),0,This);
        return 0;
    }
    return This->ref;
}

static HRESULT WINAPI IRichEditOle_fnActivateAs(IRichEditOle *me, REFCLSID rclsid,
                                       REFCLSID rclsidAs)
{
    ICOM_THIS(IRichEditOle,me);
    FIXME("Stub (%p)\n",This);
    return 0x0;
}

static HRESULT WINAPI IRichEditOle_fnContextSensitiveHelp(IRichEditOle *me, BOOL fEnterMode)
{
    ICOM_THIS(IRichEditOle,me);
    FIXME("Stub (%p)\n",This);
    return 0x0;
}

static HRESULT WINAPI IRichEditOle_fnConvertObject(IRichEditOle *me, LONG iob,
REFCLSID rclsidNew, LPCSTR lpstrUserTypeNew)
{
    ICOM_THIS(IRichEditOle,me);
    FIXME("Stub (%p)\n",This);
    return 0x0;
}

static HRESULT WINAPI IRichEditOle_fnGetClientSite(IRichEditOle *me,
LPOLECLIENTSITE *lplpolesite)
{
    ICOM_THIS(IRichEditOle,me);
    FIXME("Stub (%p)\n",This);
    return 0x0;
}

static HRESULT WINAPI IRichEditOle_fnGetClipboardData(IRichEditOle *me, CHARRANGE
*lpchrg, DWORD reco, LPDATAOBJECT *lplpdataobj)
{
    ICOM_THIS(IRichEditOle,me);
    FIXME("Stub (%p)\n",This);
    return 0x0;
}

static LONG WINAPI IRichEditOle_fnGetLinkCount(IRichEditOle *me)
{
    ICOM_THIS(IRichEditOle,me);
    FIXME("Stub (%p)\n",This);
    return 0x0;
}

static HRESULT WINAPI IRichEditOle_fnGetObject(IRichEditOle *me, LONG iob,
REOBJECT *lpreobject, DWORD dwFlags)
{
    ICOM_THIS(IRichEditOle,me);
    FIXME("Stub (%p)\n",This);
    return 0x0;
}

static LONG WINAPI IRichEditOle_fnGetObjectCount(IRichEditOle *me)
{
    ICOM_THIS(IRichEditOle,me);
    FIXME("Stub (%p)\n",This);
    return 0x0;
}

static HRESULT WINAPI IRichEditOle_fnHandsOffStorage(IRichEditOle *me, LONG iob)
{
    ICOM_THIS(IRichEditOle,me);
    FIXME("Stub (%p)\n",This);
    return 0x0;
}

static HRESULT WINAPI IRichEditOle_fnImportDataObject(IRichEditOle *me,
LPDATAOBJECT lpdataobj, CLIPFORMAT cf, HGLOBAL hMetaPict )
{
    ICOM_THIS(IRichEditOle,me);
    FIXME("Stub (%p)\n",This);
    return 0x0;
}

static HRESULT WINAPI IRichEditOle_fnInPlaceDeactivate(IRichEditOle *me )
{
    ICOM_THIS(IRichEditOle,me);
    FIXME("Stub (%p)\n",This);
    return 0x0;
}

static HRESULT WINAPI IRichEditOle_fnInsertObject(IRichEditOle *me, REOBJECT
*lpreobject)
{
    ICOM_THIS(IRichEditOle,me);
    FIXME("Stub (%p)\n",This);
    return 0x0;
}

static HRESULT WINAPI IRichEditOle_fnSaveCompleted(IRichEditOle *me, LONG iob,
LPSTORAGE lpstg)
{
    ICOM_THIS(IRichEditOle,me);
    FIXME("Stub (%p)\n",This);
    return 0x0;
}

static HRESULT WINAPI IRichEditOle_fnSetDvaspect(IRichEditOle *me, LONG iob, DWORD
dvaspect)
{
    ICOM_THIS(IRichEditOle,me);
    FIXME("Stub (%p)\n",This);
    return 0x0;
}

static HRESULT WINAPI IRichEditOle_fnSetHostNames(IRichEditOle *me, LPCSTR
lpstrContainerApp, LPCSTR lpstrContainerObj)
{
    ICOM_THIS(IRichEditOle,me);
    FIXME("Stub (%p)\n",This);
    return 0x0;
}

static HRESULT WINAPI IRichEditOle_fnSetLinkAvailable(IRichEditOle *me, LONG iob,
BOOL fAvailable)
{
    ICOM_THIS(IRichEditOle,me);
    FIXME("Stub (%p)\n",This);
    return 0x0;
}

static ICOM_VTABLE(IRichEditOle) REvt = {
    ICOM_MSVTABLE_COMPAT_DummyRTTIVALUE
    IRichEditOle_fnQueryInterface,
    IRichEditOle_fnAddRef,
    IRichEditOle_fnRelease,
    IRichEditOle_fnGetClientSite,
    IRichEditOle_fnGetObjectCount,
    IRichEditOle_fnGetLinkCount,
    IRichEditOle_fnGetObject,
    IRichEditOle_fnInsertObject,
    IRichEditOle_fnConvertObject,
    IRichEditOle_fnActivateAs,
    IRichEditOle_fnSetHostNames,
    IRichEditOle_fnSetLinkAvailable,
    IRichEditOle_fnSetDvaspect,
    IRichEditOle_fnHandsOffStorage,
    IRichEditOle_fnSaveCompleted,
    IRichEditOle_fnInPlaceDeactivate,
    IRichEditOle_fnContextSensitiveHelp,
    IRichEditOle_fnGetClipboardData,
    IRichEditOle_fnImportDataObject
};
