/*

 //LOCAL_MACHINE//SYSTEM//CurrentControllerSet/Enum/ (USB|USBSTOR)

http://www.microsoft.com/whdc/system/bus/USB/IAD.mspx

*/

/* Sub Classes  for mass storage devices */

#define MSC_SC_RBC      0x01 /* Reduced Block Commands Flash devices */
#define MSC_SC_8020     0x02 /* ATAPI  CD/DVD drives */
#define MSC_SC_QIC      0x03 /* Tape drives */
#define MSC_SC_UFI      0x04 /* Floppy */
#define MSC_SC_8070     0x05 /* Removeable media */
#define MSC_SC_SCSI     0x06 /* transparent stuff, disk drives */
#define MSC_SC_ISD200   0x07 /* ISD200 ATA stuff */
#define MSC_SC_MAX      SC_ISD200
#define MSC_SC_MIN      SC_RBC

#define USB_TERMINATE -2
#define USB_WILD -1

/* map subclass to guid */

/* Class, subclass (0 any), guid */
typedef struct usb_device_map_
{
    const INT class;
    const INT subclass;
    const GUID *devclass;
    LPCWSTR enumerator;
} usb_device_map;

static const WCHAR szUSBSTOR[] = {'u','s','b','s','t','o','r',0};
static const WCHAR szUSB[] = {'u','s','b',0};
static const WCHAR szUNKNOWN[] = {'u','n','k','n','o','w','n',0};

/* 
 * many of these are unknown and untested, 
 * this will need to be extensivly expanded on
 */
static const usb_device_map known_usb_devices[] = 
{
{USB_CLASS_MASS_STORAGE, MSC_SC_8020, &GUID_DEVCLASS_CDROM, szUSBSTOR},
{USB_CLASS_MASS_STORAGE, MSC_SC_QIC, &GUID_DEVCLASS_TAPEDRIVE, szUSBSTOR}, 
{USB_CLASS_MASS_STORAGE, MSC_SC_UFI, &GUID_DEVCLASS_FLOPPYDISK, szUSBSTOR}, 
{USB_CLASS_MASS_STORAGE, MSC_SC_SCSI, &GUID_DEVCLASS_DISKDRIVE, szUSBSTOR},
{USB_CLASS_MASS_STORAGE, MSC_SC_8070 , &GUID_DEVCLASS_DISKDRIVE, szUSBSTOR},
{USB_WILD,               USB_WILD,     &GUID_DEVCLASS_USB, szUSB },
{USB_TERMINATE,          USB_TERMINATE,&GUID_DEVCLASS_UNKNOWN, szUNKNOWN}
};

/*
 * This information should go into a mass storage driver
 * and be independed of here... however for now it will reside here.
 *
 * also see the above comment as it also applies here
 */
static const usb_device_map known_msc_interfaces[] = 
{
{USB_CLASS_MASS_STORAGE, MSC_SC_8020, &CdRomClassGuid,szUSBSTOR}, /*untested*/
{USB_CLASS_MASS_STORAGE, MSC_SC_QIC, &TapeClassGuid,szUSBSTOR}, /*untested*/
{USB_CLASS_MASS_STORAGE, MSC_SC_UFI, &FloppyClassGuid,szUSBSTOR}, /*untested*/
{USB_CLASS_MASS_STORAGE, MSC_SC_SCSI, &DiskClassGuid,szUSBSTOR},
{USB_CLASS_MASS_STORAGE, MSC_SC_8070, &DiskClassGuid,szUSBSTOR},
{USB_TERMINATE ,USB_TERMINATE ,&GUID_DEVCLASS_UNKNOWN,szUNKNOWN}
};

/* vendor ids */

typedef struct _product_string
{
    WORD id;
    WCHAR string[20];
} usb_product_string;

typedef struct _vendor_string
{
    WORD    id;
    WCHAR    string[12];
    const usb_product_string products[5];
} usb_vendor_string;


/* ALOT needs to be added here */
static const usb_vendor_string usb_vendor_product[] = 
{
    {0x05ac, {'a','p','p','l','e',0}, 
            {
            {0x1201, {'i','p','o','d',0}},
            {0x1202, {'i','p','o','d',0}},
            {0x0,{0}}
            }
    },
    { 0x0,{0},{{0x0,{0}}}}
};
